=== putt/Makefile ===
# This makefile only exists so that I can run emacs M-x compile from within
# the source directory.  See the Makefile in the parent directory

% :
	$(MAKE) -C .. $@
