=== debian/changelog ===
neverball (1.6.0+git20180603-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:02:15 +1100

neverball (1.6.0+git20180603-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:29:18 +0000

neverball (1.6.0+git20180603-3) unstable; urgency=medium

  * Switch to debhelper-compat = 13.
  * Declare compliance with Debian Policy 4.5.0.
  * Work around FTBFS with GCC 10 by compiling with -fcommon. (Closes: #957604)

 -- Markus Koschany <apo@debian.org>  Wed, 22 Jul 2020 15:41:04 +0200

neverball (1.6.0+git20180603-2) unstable; urgency=medium

  * Install the png files from the geom directory to fix graphical glitches in
    Neverball. (Closes: #871223)

 -- Markus Koschany <apo@debian.org>  Sat, 18 May 2019 15:17:26 +0200

neverball (1.6.0+git20180603-1) unstable; urgency=medium

  * New upstream snapshot 1.6.0+git20180603.
  * Switch to compat level 11.
  * Declare compliance with Debian Policy 4.3.0.
  * Use canonical VCS URI.
  * Drop libphysfs-dev from B-D.

 -- Markus Koschany <apo@debian.org>  Fri, 04 Jan 2019 19:38:45 +0100
