=== debian/control ===
Source: neverball
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Markus Koschany <apo@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libjpeg-dev,
 libopenhmd-dev [!hurd-i386 !sh4 !powerpcspe],
 libpng-dev,
 libsdl2-dev,
 libsdl2-ttf-dev,
 libvorbis-dev
Standards-Version: 4.5.0
Homepage: http://neverball.org/
Vcs-Git: https://salsa.debian.org/games-team/neverball.git
Vcs-Browser: https://salsa.debian.org/games-team/neverball

Package: neverball
Architecture: any
Depends:
 neverball-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 neverputt
Description: 3D floor-tilting game
 In the grand tradition of Marble Madness and Super Monkey Ball, Neverball
 has you guide a rolling ball through dangerous territory. Balance on narrow
 bridges, navigate mazes, ride moving platforms, and dodge pushers and
 shovers to get to the goal. Race against the clock to collect coins to earn
 extra balls.

Package: neverball-data
Architecture: all
Multi-Arch: foreign
Depends:
 neverball-common (= ${source:Version}),
 ${misc:Depends}
Suggests:
 neverball
Description: data files for Neverball
 In the grand tradition of Marble Madness and Super Monkey Ball, Neverball
 has you guide a rolling ball through dangerous territory. Balance on narrow
 bridges, navigate mazes, ride moving platforms, and dodge pushers and
 shovers to get to the goal. Race against the clock to collect coins to earn
 extra balls.
 .
 This package contains the data files needed to play Neverball.

Package: neverball-common
Architecture: all
Multi-Arch: foreign
Depends:
 fonts-dejavu-core,
 ${misc:Depends}
Suggests:
 fonts-wqy-microhei
Description: data files for Neverball and Neverputt
 The engine of the floor-tilting game Neverball is also used by its spin-off,
 a miniature golf game known as Neverputt.
 .
 This package contains the data files shared between Neverball and Neverputt.

Package: neverputt
Architecture: any
Depends:
 neverputt-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 neverball
Description: 3D miniature golf game
 Neverputt is a hot-seat multi-player miniature golf game for 1 to 4 players.
 The 18-hole course takes advantage of all the elements that challenge
 Neverball players, including moving platforms and barriers, teleporters,
 ramps, and drop-offs. A simple putting interface and golf scoring system
 have been added.

Package: neverputt-data
Architecture: all
Multi-Arch: foreign
Depends:
 neverball-common (= ${source:Version}),
 ${misc:Depends}
Suggests:
 neverputt
Description: data files for Neverputt
 Neverputt is a hot-seat multi-player miniature golf game for 1 to 4 players.
 The 18-hole course takes advantage of all the elements that challenge
 Neverball players, including moving platforms and barriers, teleporters,
 ramps, and drop-offs. A simple putting interface and golf scoring system
 have been added.
 .
 This package contains the data files needed to play Neverputt.
